Attribute VB_Name = "UnZip"
Option Explicit
Private Declare Function Wiz_SingleEntryUnzip Lib "UnZip32.dll" (ByVal ifnc As Long, ByRef ifnv As UNZIPnames, ByVal xfnc As Long, ByRef xfnv As UNZIPnames, dcll As DCLIST, Userf As USERFUNCTION) As Long
Private Type UNZIPnames
    uzFiles(0 To 99) As String
End Type
Private Type UNZIPCBChar
    ch(32800) As Byte
End Type
Private Type UNZIPCBCh
    ch(256) As Byte
End Type
Private Type DCLIST
    ExtractOnlyNewer  As Long
    SpaceToUnderscore As Long
    PromptToOverwrite As Long
    fQuiet            As Long
    ncflag            As Long
    ntflag            As Long
    nvflag            As Long
    nfflag            As Long
    nzflag            As Long
    ndflag            As Long
    noflag            As Long
    naflag            As Long
    nZIflag           As Long
    C_flag            As Long
    fPrivilege        As Long
    Zip               As String
    ExtractDir        As String
End Type
Private Type USERFUNCTION
    UZDLLPrnt     As Long
    UZDLLSND      As Long
    UZDLLREPLACE  As Long
    UZDLLPASSWORD As Long
    UZDLLMESSAGE  As Long
    UZDLLSERVICE  As Long
    TotalSizeComp As Long
    TotalSize     As Long
    CompFactor    As Long
    NumMembers    As Long
    cchComment    As Integer
End Type
Private UZDCL  As DCLIST
Private UZUSER As USERFUNCTION
Public uExtractOnlyNewer As Integer
Public uSpaceUnderScore  As Integer
Public uPromptOverWrite  As Integer
Public uQuiet            As Integer
Public uWriteStdOut      As Integer
Public uTestZip          As Integer
Public uExtractList      As Integer
Public uFreshenExisting  As Integer
Public uDisplayComment   As Integer
Public uHonorDirectories As Integer
Public uOverWriteFiles   As Integer
Public uConvertCR_CRLF   As Integer
Public uVerbose          As Integer
Public uPrivilege        As Integer
Public uZipFileName      As String
Public uExtractDir       As String
Public uZipNames         As UNZIPnames
Public uExcludeNames     As UNZIPnames
Private Function FnPtr(ByVal lp As Long) As Long
FnPtr = lp
End Function
Private Function UZDLLPrnt(ByRef fname As UNZIPCBChar, ByVal x As Long) As Long
UZDLLPrnt = 0
End Function
Private Function UZDLLServ(ByRef mname As UNZIPCBChar, ByVal x As Long) As Long
UZDLLServ = 0
End Function
Private Function UZDLLRep(ByRef fname As UNZIPCBChar) As Long
UZDLLRep = 103
End Function
Private Function UZDLLPass(ByRef p As UNZIPCBCh, ByVal n As Long, ByRef m As UNZIPCBCh, ByRef Name As UNZIPCBCh) As Integer
UZDLLPass = 0
End Function
Public Function VBUnZip32() As Long

uPromptOverWrite = 0
uOverWriteFiles = 1
uDisplayComment = 0
uExtractList = 0
uHonorDirectories = 0
uExcludeNames.uzFiles(0) = vbNullString

UZDCL.ExtractOnlyNewer = uExtractOnlyNewer ' 1 = Extract Only Newer/New
UZDCL.SpaceToUnderscore = uSpaceUnderScore ' 1 = Convert Space To Underscore
UZDCL.PromptToOverwrite = uPromptOverWrite ' 1 = Prompt To Overwrite Required
UZDCL.fQuiet = uQuiet                      ' 2 = No Messages 1 = Less 0 = All
UZDCL.ncflag = uWriteStdOut                ' 1 = Write To Stdout
UZDCL.ntflag = uTestZip                    ' 1 = Test Zip File
UZDCL.nvflag = uExtractList                ' 0 = Extract 1 = List Contents
UZDCL.nfflag = uFreshenExisting            ' 1 = Update Existing by Newer
UZDCL.nzflag = uDisplayComment             ' 1 = Display Zip File Comment
UZDCL.ndflag = uHonorDirectories           ' 1 = Honour Directories
UZDCL.noflag = uOverWriteFiles             ' 1 = Overwrite Files
UZDCL.naflag = uConvertCR_CRLF             ' 1 = Convert CR To CRLF
UZDCL.nZIflag = uVerbose                   ' 1 = Zip Info Verbose
UZDCL.C_flag = 1                           ' 1 = Case insensitivity, 0 = Case Sensitivity
UZDCL.fPrivilege = uPrivilege              ' 1 = ACL 2 = Priv
UZDCL.Zip = uZipFileName                   ' ZIP Filename
UZDCL.ExtractDir = uExtractDir             ' Extraction Dir, NULL If Extracting To Current
UZUSER.UZDLLPrnt = FnPtr(AddressOf UZDLLPrnt)
UZUSER.UZDLLSND = 0& ' <-- Not Supported
UZUSER.UZDLLREPLACE = FnPtr(AddressOf UZDLLRep)
UZUSER.UZDLLPASSWORD = FnPtr(AddressOf UZDLLPass)
UZUSER.UZDLLSERVICE = FnPtr(AddressOf UZDLLServ)

VBUnZip32 = Wiz_SingleEntryUnzip(1&, uZipNames, 0&, uExcludeNames, UZDCL, UZUSER)
End Function
